package sample.customer.web.controller;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

@Controller
public class FileUploadController {
	private static final Log LOG = LogFactory.getLog(FileUploadController.class);

    @RequestMapping(value = "/upload", method = RequestMethod.GET)
    public String showUploadForm() {
        return "upload";
    }

    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    public String uploadFile(
        @RequestParam("uploadFile") MultipartFile multipartFile) 
                                            throws IOException{
        // 파일명 
        String fileName = multipartFile.getOriginalFilename();
        // 파일 크기(단위는 byte)
        long size = multipartFile.getSize();
        // 컨텐츠 타입
        String contentType = multipartFile.getContentType();
        // 내용(byte배열)
        byte[] fileContents = multipartFile.getBytes();

        // 파일로 저장 
        multipartFile.transferTo(new File("/tmp/" + fileName));

        InputStream is = null;
        try {
            // 파일 내용을 읽기 위한 InputStream
            is = multipartFile.getInputStream();

            // InputStream을 사용한 처리
        } finally {
        	// 반드시 close한다 
            is.close();
        }

        LOG.trace("size=" + size);
        LOG.trace("contentType=" + contentType);
        LOG.trace("fileContents=" + new String(fileContents, "UTF-8"));

        return "redirect:/upload";
    }
}
